//+------------------------------------------------------------------+
//|                                                  TradeSystem.mq4 |
//|                                 Copyright  2007   |
//|                                                los@we.kherson.ua |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,   "
#property link      "mailto: los@we.kherson.ua"

double MinLot=0.1; //  ,       
int LotDigit = 2; //     

#define Magic 100

extern int TS = 20; //  
extern int SL = 60;// 
extern int Step=55; //  
int Slip=1; //
int preDir=OP_BUY;
int Ticket[1000];

//---------------------------------------------------------------------------

void Process()
{
//	double lots = AccountFreeMargin()*0.1*0.00001; //  = 100 ..  100000 .. ( 1/1000)
	double lots = AccountFreeMargin()*0.1*0.00001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//      
	
	double price = 0.0;
	int total, i, Signal, pos;

//----     
	total = CreatTicketArray(OP_BUY, Magic);
	if (preDir==OP_SELL && total<=0)	//----  ,  
	{
		total = CreatTicketArray(OP_BUYSTOP, Magic);
		if (total<=0)	//----  ,  
			OrderSend(Symbol(), OP_BUYSTOP, lots, Ask+Step*Point, Slip, Ask-SL*Point, 0, "", Magic, 0, CLR_NONE);
	}
	else if (total>0) preDir = OP_BUY;
//-----    
	total = CreatTicketArray(OP_SELL, Magic); 
	if (preDir==OP_BUY && total<=0)	// ,  
	{
		total = CreatTicketArray(OP_SELLSTOP, Magic); 
		if (total<=0)	// ,  
			OrderSend(Symbol(), OP_SELLSTOP, lots, Bid-Step*Point, Slip, Bid+SL*Point, 0, "", Magic, 0, CLR_NONE);
	}
	else if (total>0) preDir=OP_SELL;
}

//+------------------------------------------------------------------+

void Trailing()
{
	int i, total = OrdersTotal();	if (total<=0) return;
	double avgLevel;
	total = CreatTicketArray(OP_BUY, Magic);
	if (total>0) //  OP_BUY
	{
		OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice();
		if (Bid-avgLevel>=0)
		{
			//     
			if ((Bid-avgLevel>TS*Point) && OrderStopLoss()<avgLevel) OrderModify(Ticket[1],0, avgLevel+1*Point, 0, 0, CLR_NONE);
			//     +
			if ((Bid-OrderStopLoss()>TS*Point) && OrderStopLoss()>avgLevel) OrderModify(Ticket[1],0,Bid-TS*Point, 0, 0, CLR_NONE);
		}
	}//OP_BUY
	else
	{
		total = CreatTicketArray(OP_BUYSTOP, Magic);
		if (total>0)
		{
			OrderSelect(Ticket[1], SELECT_BY_TICKET); 
			if (OrderOpenPrice()-Ask>Step*Point) OrderModify(Ticket[1], Ask+Step*Point, Ask-SL*Point, 0, 0, CLR_NONE);
		}
	}
	total = CreatTicketArray(OP_SELL, Magic);
	if (total>0) //
	{
		OrderSelect(Ticket[1], SELECT_BY_TICKET); avgLevel=OrderOpenPrice();
		if (avgLevel-Ask>=0)
		{
			if ((avgLevel-Ask>TS*Point) && OrderStopLoss()>avgLevel) OrderModify(Ticket[1],0, avgLevel-1*Point, 0, 0, CLR_NONE);
			if ((OrderStopLoss()-Ask>TS*Point) && OrderStopLoss()<avgLevel)	OrderModify(Ticket[1],0,Ask+TS*Point, 0,0, CLR_NONE);
		}
	}//OP_SELL
	else
	{
		total = CreatTicketArray(OP_SELLSTOP, Magic);
		if (total>0)
		{
			OrderSelect(Ticket[1], SELECT_BY_TICKET); 
			if (Bid-OrderOpenPrice()>Step*Point) OrderModify(Ticket[1], Bid-Step*Point, Bid+SL*Point, 0, 0, CLR_NONE);
		}
	}
	return;
}
//---------------------------------------------------------------------------
int init()  {   return(0);  }
int deinit()  {  	return(0);  }

//---------------------------------------------------------------------------
void start()
{
	Process();	Trailing();
}

//---------------------------------------------------------------------------

int CreatTicketArray(int dir, int SysID)
{
   int total=OrdersTotal(), i, c=1; if (total<=0) return (0);
	for(i=0;i<total;i++) { OrderSelect(i, SELECT_BY_POS); if ((OrderType()==dir) && (OrderMagicNumber()==SysID)) { Ticket[c] = OrderTicket(); c++; } }
	return (c-1);
}


